-- A3Pv2.8/test2_INC8/Wrap_ALU8.vhdl
-- version dim. déc.  8 08:07:34 CET 2019 : forked from INC8_tb.vhdl
-- version lun. déc. 16 02:52:27 CET 2019 : derived from Wrap_INC8.vhdl
-- version mar. déc. 24 21:20:49 CET 2019 : dropped the decoder
--
-- Wraps the ALU8 only.
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 23;
    VectGenWidthOut: integer := 19
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: out std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_ALU8 of VG_Wrapper is
begin

  -- here we "wire" the unit to the Vector Generator ports:
  tb: entity ALU8 port map (
     CMPS     => VectIn(16),
     Rop2Mx   => VectIn(17),
     OrXor    => VectIn(18),
     PassMask => VectIn(19),
     NEG      => VectIn(20),
     Cin      => VectIn(21),
     SRI      => VectIn(7 downto 0),
     SND      => VectIn(15 downto 8),
     SUM      => VectOut(7 downto 0),
     ROP2     => VectOut(15 downto 8),
     Cout     => VectOut(16));
  -- the wires that enable size autodetection
  VectOut(17) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(22);
end Wrap_ALU8;
